#include "DSP28x_Project.h"     // Device Headerfile and Examples Include File
#include "LCD_driver.h"
#include "NolibM.h"
#include "ball.h"
#include "spi_lcd.h"

static void ball_update_(BALL *);

static BALL sBall;// {[
static void initBall_(BALL *b)
{
	b->x=131/2+10;
	b->y=131/2;
	b->lastx=b->x;
	b->lasty=b->y;
	b->size=8;
	b->dx=5;	
	b->dy=4;
}

void ball_init(void)
{
	initBall_(&sBall);
}


void ball_update(void)
{
	ball_update_(&sBall);
}

static void ball_update_(BALL *b)
{
	int size=b->size;
	int x=b->x;
	int y=b->y;
	int nx, ny;// ̃{[ʒu
	int sx, sy;// `startx

	nx=x+b->dx;
	ny=y+b->dy;

	if(nx+size>getLcd()->lx){
		sx=getLcd()->lx-size;
		b->dx*=-1;
	}
	else if(nx<0){
		sx=0;
		b->dx*=-1;
	}else{
		sx=nx;
	}
	b->x=sx;

	if(ny+size>getLcd()->ly){
		sy=getLcd()->ly-size;
		b->dy*=-1;
	}
	else if(ny<0){
		sy=0;
		b->dy*=-1;
	}
	else{
		sy=ny;
	}
	b->y=sy;

	b->lastx=sx;
	b->lasty=sy;
}

void ball_erace(int color)
{
	BALL *b=&sBall;
	int x=b->x;
	int y=b->y;
	int size=b->size;
	Uint16 cmd;

	cmd=isEpson()?PASET:PASETP;// EPSON:PHILIPS

	LCDCommand(cmd);
	LCDData(x);
	LCDData(x+size);

	cmd=isEpson()?CASET:CASETP;// EPSON:PHILIPS
	LCDCommand(cmd);
	LCDData(y);
	LCDData(y+size);

	{
		unsigned int i;
		cmd=isEpson()?RAMWR:RAMWRP;// EPSON:PHILIPS
		LCDCommand(cmd);

		for(i=0; i < (size*size)/2; i++)
		{
			LCDData((color>>4)&0x00FF);
			LCDData(((color&0x0F)<<4)|(color>>8));
			LCDData(color&0x0FF);  	// nop(EPSON)
		}
	}

}

void ball_draw(int color)
{
	BALL *b=&sBall;
	int size=b->size;
	int sx,ex,sy,ey;
	Uint16 cmd;

	sx=b->x;
	ex=sx+size;
	sy=b->y;
	ey=sy+size;

	cmd=isEpson()?PASET:PASETP;// EPSON:PHILIPS
	LCDCommand(cmd);
	LCDData(sx);
	LCDData(ex);
	cmd=isEpson()?CASET:CASETP;// EPSON:PHILIPS
	LCDCommand(cmd);
	LCDData(sy);
	LCDData(ey);

	{
		unsigned int i;
		cmd=isEpson()?RAMWR:RAMWRP;// EPSON:PHILIPS
		LCDCommand(cmd);

		for(i=0; i < (size*size)/2; i++)
		{
			LCDData((color>>4)&0x00FF);
			LCDData(((color&0x0F)<<4)|(color>>8));
			LCDData(color&0x0FF);  	// nop(EPSON)
		}
	}

	
}

