#include <string.h>
#include "DSP28x_Project.h"
#include "LCD_driver.h"
#include "NolibM.h"
#include "input.h"
#include "spi_lcd.h"
#include "ball.h"

// spi
void spi_xmit(Uint16 a);
void spi_fifo_init(void);
void spi_init(void);

// manager
void init();
void draw();
void update();
void clear();


void LCDPutStr(char *pString, int x, int y, int Size, int fColor, int bColor);

int g_timer;

void main(void)
{
	// pbg systemݒ
	InitSysCtrl();

	// ^C}[֌W
	InitCpuTimers();
	// CpuTimer2gݒ
	ConfigCpuTimer(&CpuTimer2, 60, 1000); //1[ms]waitp: CPU^C}[ݒiCPU^C}[QCCPUFreq=60MHzC1000[us]j
	CpuTimer2Regs.TCR.all = 0x4001;	// Use write-only instruction to set TSS bit = 0	

	// ̑GPIOgݒ
	{
		EALLOW;// enable registar access

		// for LEDs
		GpioCtrlRegs.GPAMUX1.bit.GPIO1 = 0;		// 0=GPIO,  1=EPWM1B,  2=Resv,  3=COMP1OUT
		GpioCtrlRegs.GPADIR.bit.GPIO1 = 1;		// 1=OUTput,  0=INput 
		GpioDataRegs.GPASET.bit.GPIO1 = 1;	// uncomment if --> Set Low initially
		//	GpioDataRegs.GPACLEAR.bit.GPIO1 = 1;	// uncomment if --> Set Low initially

		GpioCtrlRegs.GPAMUX1.bit.GPIO3 = 0;		// 0=GPIO,  1=EPWM2B,  2=SPISOMI-A,  3=COMP2OUT
		GpioCtrlRegs.GPADIR.bit.GPIO3 = 1;		// 1=OUTput,  0=INput 
		GpioDataRegs.GPASET.bit.GPIO3 = 1;	// uncomment if --> Set Low initially
		//	GpioDataRegs.GPACLEAR.bit.GPIO3 = 1;	// uncomment if --> Set Low initially

		GpioCtrlRegs.GPAMUX1.bit.GPIO5 = 0;		// 0=GPIO,  1=EPWM2B,  2=SPISOMI-A,  3=COMP2OUT
		GpioCtrlRegs.GPADIR.bit.GPIO5 = 1;		// 1=OUTput,  0=INput 
		GpioDataRegs.GPASET.bit.GPIO5 = 1;	// uncomment if --> Set Low initially
		//	GpioDataRegs.GPACLEAR.bit.GPIO5 = 1;	// uncomment if --> Set Low initially

		GpioCtrlRegs.GPAMUX1.bit.GPIO7 = 0;		// 0=GPIO,  1=EPWM2B,  2=SPISOMI-A,  3=COMP2OUT
		GpioCtrlRegs.GPADIR.bit.GPIO7 = 1;		// 1=OUTput,  0=INput 
		GpioDataRegs.GPASET.bit.GPIO7 = 1;	// uncomment if --> Set Low initially
		//	GpioDataRegs.GPACLEAR.bit.GPIO7 = 1;	// uncomment if --> Set Low initially

		// for sw1
		GpioCtrlRegs.GPAMUX2.bit.GPIO30 = 0;	// 0=GPIO,  1=CANRX-A,  2=Resv,  3=Resv
		GpioCtrlRegs.GPADIR.bit.GPIO30 = 0;		// 1=OUTput,  0=INput 
		// for sw2
		GpioCtrlRegs.GPAMUX2.bit.GPIO31 = 0;	// 0=GPIO,  1=CANTX-A,  2=Resv,  3=Resv
		GpioCtrlRegs.GPADIR.bit.GPIO31 = 0;		// 1=OUTput,  0=INput 

		// for SPI Reset
		GpioCtrlRegs.GPBMUX1.bit.GPIO42 = 0;
		GpioCtrlRegs.GPBDIR.bit.GPIO42 = 1;		// 1=OUTput,  0=INput 
		GpioDataRegs.GPBSET.bit.GPIO42 = 1;		// 1=OUTput,  0=INput

		EDIS;	// Disable register access
	}

	// SPIgpݒ
	InitSpiGpio();// A/Bgݒ

	DINT;// 荞݌nytFe[ȕ@荞݂s

	InitPieCtrl();

	IER = 0x0000;
	IFR = 0x0000;
   
	InitPieVectTable();

	// SPI
	spi_fifo_init();	// Initialize the Spi FIFO
	spi_init();		  	// init SPI


	init();
	
	g_timer=0;
	for(;;)
	{    
		g_timer++;
		input();
		update();
		draw();

		wait(33);// 33ms

		// Ƌ
		clear();
	}
} 	





// spiݒ֌W
void spi_init()
{    
	getSpi()->SPICCR.bit.SPISWRESET=0;// reset SPI
	getSpi()->SPICTL.all =0x0006;				// Enable master mode, normal phase,
													// disable talk, and SPI int disabled.
	getSpi()->SPICCR.all =0x0048;				// falling edge, 9-bit char bits	
	getSpi()->SPIBRR =0x0000;					// Baud rate: LSPCLK / 4    (30MHz / )  30 000 000   LSPCLK/4=
	getSpi()->SPIPRI.all=0x0000;				// Set so breakpoints don't disturb xmission
	getSpi()->SPIPRI.bit.FREE=1;// debugł

	getSpi()->SPICCR.bit.SPISWRESET=1;// Enable SPI
}

void spi_fifo_init()										
{
// Initialize SPI FIFO registers
    getSpi()->SPIFFTX.all=0xE040;
    getSpi()->SPIFFRX.all=0x2044;
    getSpi()->SPIFFCT.all=0x0;
}  
void spi_xmit(Uint16 data)
{
	// l߂őMobt@ɃZbg
    getSpi()->SPITXBUF=(data<<(16-9));// sizeof(SPITXBUF) - 9bit
}    







// isǗ֌W
// 
void init()
{
	// input
	input_init();

	// fBXvC
	LCDInit();

	// {[
	ball_init();
}

// `NA(x̊֌WŕNA)
void clear()
{
	ball_erace(YELLOW);
}


// XV
void update()
{
	if(input_getTrg(INPUT_SW1_ON)){
		// sw1 OFF->ON
		ledFlash(ON,1);
		ledFlash(ON,2);
	}
	if(input_getRTrg(INPUT_SW1_ON)){
		// sw1 ON->OFF
		ledFlash(OFF,1);
		ledFlash(OFF,2);
		LCDInit();
	}
	if(input_getTrg(INPUT_SW1_OFF)){
		// sw1 ON->OFF
		ledFlash(ON,3);
		ledFlash(ON,4);
	}
	if(input_getRTrg(INPUT_SW1_OFF)){
		// sw1 OFF->ON
		ledFlash(OFF,3);
		ledFlash(OFF,4);		
	}

	ball_update();
}

// `
void draw()
{

	// `
	{
		static char strSrc[]="Spi Display Demo   fuRo ";
		char str[16];
		int num=0;

		num=(g_timer>>2)%strlen(strSrc);

		if(strlen(strSrc)-num<16){
			strncpy(str,&strSrc[num],strlen(strSrc)-num);
			strncpy(&str[strlen(strSrc)-num],&strSrc[0],16-(strlen(strSrc)-num));
			LCDPutStr(str, 0,0,2/*LARGE*/,BLACK,WHITE);
		}
		else{
			strncpy(str,&strSrc[num],16);
			LCDPutStr(str, 0,0,2/*LARGE*/,BLACK,WHITE);
		}
	}

	// {[̕`
	ball_draw(BLUE);
}


//===========================================================================
// No more.
//===========================================================================
